{$APPTYPE CONSOLE}

program fir;
var
  t1, t2: array[1..1000] of integer;
  s1, s2: array[0..1000] of integer;
  tt: integer;
  n, m: integer;
  res: integer;
  i, j: integer;

  procedure swapint(var a, b: integer);
  var
    tmp: integer;
  begin
    tmp := a;
    a := b;
    b := tmp;
  end;

  function max(a, b: integer): integer;
  begin
    if (a > b) then
      Result := a
    else
      Result := b;
  end;

begin
  assign(input, 'input.txt');
  reset(input);
  assign(output, 'output.txt');
  rewrite(output);

  assert(not SeekEof(input));
  read(tt);
  assert((1 <= tt) and (tt <= 10000));
  assert(not SeekEof(input));
  read(n);
  assert((1 <= n) and (n <= 1000));
  for i := 1 to n do
  begin
    assert(not SeekEof(input));
    read(t1[i]);
    assert((1 <= t1[i]) and (t1[i] <= 10000));
  end;
  assert(not SeekEof(input));
  read(m);
  assert((1 <= m) and (m <= 1000));
  for i := 1 to m do
  begin
    assert(not SeekEof(input));
    read(t2[i]);
    assert((1 <= t2[i]) and (t2[i] <= 10000));
  end;
  assert(SeekEof(input));

  for i := 1 to n do
  begin
    for j := i+1 to n do
    begin
      if (t1[i] > t1[j]) then
        swapint(t1[i], t1[j]);
    end;
  end;
  for i := 1 to m do
  begin
    for j := i+1 to m do
    begin
      if (t2[i] > t2[j]) then
        swapint(t2[i], t2[j]);
    end;
  end;

  s1[0] := 0;
  for i := 1 to n do
    s1[i] := s1[i-1] + t1[i];
  s2[0] := 0;
  for i := 1 to m do
    s2[i] := s2[i-1] + t2[i];

  res := 0;
  for i := 0 to n do
  begin
    for j := 0 to m do
    begin
      if (s1[i] + s2[j] <= tt) then
        res := max(res, i*5000 + j*2000);
    end;
  end;

  write(res);

  close(input);
  close(output);
end.